<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../stylesheet.css">
<link rel="start" href="../../overview-summary.html">

<title>tests/doctorTestCase.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/tests/doctortestcase.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>tests/doctorTestCase.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>    require_once 'simpletest'.DIRECTORY_SEPARATOR.'unit_tester.php';
<a name="line3"></a>	
<a name="line4"></a>    /**
<a name="line5"></a>     * Base test class to run PHPDoctor and capture output
<a name="line6"></a>     *
<a name="line7"></a>     * @package PHPDoctor\Tests
<a name="line8"></a>     */
<a name="line9"></a>    class DoctorTestCase extends UnitTestCase {
<a name="line10"></a>        
<a name="line11"></a>        var $iniPath, $appDir, $testDir, $caseDir, $iniDir, $outputDir, $tempDir;
<a name="line12"></a>        
<a name="line13"></a>        function DoctorTestCase ($label = false) {
<a name="line14"></a>			$this->UnitTestCase($label);
<a name="line15"></a>			
<a name="line16"></a>            $this->appDir    = dirname(dirname(__file__)).DIRECTORY_SEPARATOR;
<a name="line17"></a>			$this->testDir   = $this->appDir.'tests'.DIRECTORY_SEPARATOR;
<a name="line18"></a>			$this->caseDir   = $this->testDir.'cases'.DIRECTORY_SEPARATOR;
<a name="line19"></a>            $this->iniDir 	 = $this->caseDir.'ini'.DIRECTORY_SEPARATOR;
<a name="line20"></a>            $this->outputDir = $this->caseDir.'output'.DIRECTORY_SEPARATOR;
<a name="line21"></a>            $this->tempDir   = $this->caseDir.'temp'.DIRECTORY_SEPARATOR;
<a name="line22"></a>        }
<a name="line23"></a>        
<a name="line24"></a>        function setIniFile( $iniFileName ) {
<a name="line25"></a>            $this->iniPath = $this->iniDir.$iniFileName;
<a name="line26"></a>        }
<a name="line27"></a>        
<a name="line28"></a>        /**
<a name="line29"></a>         * Command line invocation to run PHPDoctor, independent of OS and include dir settings.
<a name="line30"></a>         * Call setIniFile first.
<a name="line31"></a>         *
<a name="line32"></a>         * @return string 	PHPDoctor messages
<a name="line33"></a>         */
<a name="line34"></a>        function runPhpDoctor () {
<a name="line35"></a>            if (!file_exists($this->iniPath)) exit("\n\nini file for test not found or undefined\n\n");
<a name="line36"></a>            
<a name="line37"></a>            $errorReporting = (string)(error_reporting() & ~2048); // Make sure E_STRICT is disabled
<a name="line38"></a>            
<a name="line39"></a>			ob_start();
<a name="line40"></a>            passthru(PHP . " -d error_reporting=$errorReporting \"{$this->appDir}phpdoc.php\" \"{$this->iniPath}\"");
<a name="line41"></a>			return ob_get_clean();
<a name="line42"></a>        }
<a name="line43"></a>        
<a name="line44"></a>        function readOutputFile($filename) {
<a name="line45"></a>            return file_get_contents('cases/output/'.$filename);
<a name="line46"></a>        }
<a name="line47"></a>		
<a name="line48"></a>		/**
<a name="line49"></a>		 * Reports an error if the $string does not contain $expected.
<a name="line50"></a>		 *
<a name="line51"></a>		 * Can be set to ignore insignificant whitespace in HTML output. Any whitespace in $expected is then
<a name="line52"></a>		 * allowed to be expanded in $string.
<a name="line53"></a>		 *
<a name="line54"></a>		 * If you want to capture whitespace in $string which may also be completely absent, use a pipe in
<a name="line55"></a>		 * $expected (e.g. '<td>|<tr>A cell</tr>|</td>'). If $expected happens to contain a literal pipe,
<a name="line56"></a>		 * escape it with another pipe ('||').
<a name="line57"></a>		 * 
<a name="line58"></a>		 * @param string $expected                     the needle
<a name="line59"></a>		 * @param string $string                       the haystack
<a name="line60"></a>		 * @param bool   $ignoreInsigificantWhitespace allows for additional space, tab and newline chars
<a name="line61"></a>		 * 
<a name="line62"></a>		 * @return bool
<a name="line63"></a>		 */
<a name="line64"></a>		function assertStringContains( $expected, $string, $ignoreInsigificantWhitespace = false ) {
<a name="line65"></a>			
<a name="line66"></a>			$contained = $this->inStr($string, $expected, $ignoreInsigificantWhitespace);
<a name="line67"></a>			return $this->assertTrue($contained);
<a name="line68"></a>			
<a name="line69"></a>		}
<a name="line70"></a>	
<a name="line71"></a>		/**
<a name="line72"></a>		 * Reports an error if the $string contains $expected. Inverse of assertStringContains().
<a name="line73"></a>		 *
<a name="line74"></a>		 * @param string $expected                     the needle
<a name="line75"></a>		 * @param string $string                       the haystack
<a name="line76"></a>		 * @param bool   $ignoreInsigificantWhitespace allows for additional space, tab and newline chars
<a name="line77"></a>		 * 
<a name="line78"></a>		 * @return bool
<a name="line79"></a>		 */
<a name="line80"></a>		function assertStringDoesNotContain( $expected, $string, $ignoreInsigificantWhitespace = false ) {
<a name="line81"></a>			
<a name="line82"></a>			$contained = $this->inStr($string, $expected, $ignoreInsigificantWhitespace);
<a name="line83"></a>			return $this->assertFalse($contained);
<a name="line84"></a>			
<a name="line85"></a>		}
<a name="line86"></a>		
<a name="line87"></a>		/**
<a name="line88"></a>		 * Returns if $haystack contains $needle. 
<a name="line89"></a>		 *
<a name="line90"></a>		 * Can be set to ignore insignificant whitespace in HTML output. Any whitespace in $expected is then
<a name="line91"></a>		 * allowed to be expanded in $string.
<a name="line92"></a>		 *
<a name="line93"></a>		 * If you want to capture whitespace in $string which may also be completely absent, use a pipe in
<a name="line94"></a>		 * $expected (e.g. '<td>|<tr>A cell</tr>|</td>'). If $expected happens to contain a literal pipe,
<a name="line95"></a>		 * escape it with another pipe ('||').
<a name="line96"></a>		 * 
<a name="line97"></a>		 * (Quick and dirty solution for pipe escaping. Will get off track if the needle contains a chr(1) -
<a name="line98"></a>		 * which is rather unlikely.)
<a name="line99"></a>		 * 
<a name="line100"></a>		 * @param string $haystack                     the haystack
<a name="line101"></a>		 * @param string $needle                       the needle (oh, really?!)
<a name="line102"></a>		 * @param bool $ignoreInsigificantWhitespace   allows for additional space, tab and newline chars
<a name="line103"></a>		 * 
<a name="line104"></a>		 * @return bool
<a name="line105"></a>		 */
<a name="line106"></a>		function inStr( $haystack, $needle, $ignoreInsigificantWhitespace = false ) {
<a name="line107"></a>			
<a name="line108"></a>			if ($ignoreInsigificantWhitespace) {
<a name="line109"></a>				$needle = preg_quote($needle, '/');
<a name="line110"></a>				
<a name="line111"></a>				$needle = str_replace('\|\|', chr(1), $needle);
<a name="line112"></a>				$needle = preg_replace('%\\\\\|\s+%', ' ', $needle);
<a name="line113"></a>				$needle = preg_replace('%\s+\\\\\|%', ' ', $needle);
<a name="line114"></a>				$needle = str_replace('\|', '\s*', $needle);
<a name="line115"></a>				$needle = str_replace(chr(1), '\|', $needle);
<a name="line116"></a>				
<a name="line117"></a>				$needle = preg_replace('/\s+/', '\\s+', $needle);
<a name="line118"></a>				
<a name="line119"></a>				$contained = (bool) preg_match("/$needle/", $haystack);
<a name="line120"></a>			} else {
<a name="line121"></a>				$contained = (strpos($haystack, $needle)!==false);
<a name="line122"></a>			}
<a name="line123"></a>			
<a name="line124"></a>			return $contained;
<a name="line125"></a>		}
<a name="line126"></a>		
<a name="line127"></a>		/**
<a name="line128"></a>		 * Reports an error if the $string does not contain $expected. $expected is a regular expression including 
<a name="line129"></a>		 * delimiters and any modifiers.
<a name="line130"></a>		 *
<a name="line131"></a>		 * @param string $expected                     the needle, as a regular expression
<a name="line132"></a>		 * @param string $string                       the haystack
<a name="line133"></a>		 * 
<a name="line134"></a>		 * @return bool
<a name="line135"></a>		 */
<a name="line136"></a>		function assertStringContainsRx( $expectedRx, $string ) {
<a name="line137"></a>			
<a name="line138"></a>			$contained = $this->inStrRx($string, $expectedRx);
<a name="line139"></a>			return $this->assertTrue($contained);
<a name="line140"></a>			
<a name="line141"></a>		}
<a name="line142"></a>		
<a name="line143"></a>		/**
<a name="line144"></a>		 * Reports an error if the $string contains $expected. Inverse of assertStringContainsRx().
<a name="line145"></a>		 *
<a name="line146"></a>		 * @param string $expected                     the needle, as a regular expression
<a name="line147"></a>		 * @param string $string                       the haystack
<a name="line148"></a>		 * 
<a name="line149"></a>		 * @return bool
<a name="line150"></a>		 */
<a name="line151"></a>		function assertStringDoesNotContainRx( $expectedRx, $string ) {
<a name="line152"></a>			
<a name="line153"></a>			$contained = $this->inStrRx($string, $expectedRx);
<a name="line154"></a>			return $this->assertFalse($contained);
<a name="line155"></a>			
<a name="line156"></a>		}
<a name="line157"></a>		
<a name="line158"></a>		/**
<a name="line159"></a>		 * Returns if $haystack contains $needle. $needle is a regular expression including delimiters and modifiers.
<a name="line160"></a>		 *
<a name="line161"></a>		 * @param string $haystack                     the haystack
<a name="line162"></a>		 * @param string $needle                       the needle, as a regular expression.
<a name="line163"></a>		 * 
<a name="line164"></a>		 * @return bool
<a name="line165"></a>		 */
<a name="line166"></a>		function inStrRx( $haystack, $needle ) {
<a name="line167"></a>			
<a name="line168"></a>			$contained = (bool) preg_match($needle, $haystack);
<a name="line169"></a>			
<a name="line170"></a>			return $contained;
<a name="line171"></a>		}
<a name="line172"></a>		
<a name="line173"></a>		function clearTempDir() {
<a name="line174"></a>			$this->removeDir($this->tempDir);
<a name="line175"></a>		}
<a name="line176"></a>		
<a name="line177"></a>		function clearOutputDir() {
<a name="line178"></a>			$this->removeDir($this->outputDir);
<a name="line179"></a>		}
<a name="line180"></a>		
<a name="line181"></a>		function removeDir($dir) {
<a name="line182"></a>			
<a name="line183"></a>			if(file_exists($dir)){
<a name="line184"></a>				foreach ( new DirectoryIterator($dir) as $file ) {
<a name="line185"></a>					if ( $file->isDir() ) {
<a name="line186"></a>						if ( !$file->isDot() ) {
<a name="line187"></a>							$this->removeDir($file->getPathname());
<a name="line188"></a>						} 
<a name="line189"></a>					} else {
<a name="line190"></a>						unlink($file->getPathname());
<a name="line191"></a>					}
<a name="line192"></a>				}
<a name="line193"></a>				
<a name="line194"></a>				rmdir($dir);
<a name="line195"></a>			}
<a name="line196"></a>		}
<a name="line197"></a>		
<a name="line198"></a>    }
<a name="line199"></a>    
<a name="line200"></a>?></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/tests/doctortestcase.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>